"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DatabaseItem = void 0;
const react_1 = __importStar(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const constants_1 = require("./constants");
const tree_item_1 = require("./tree-item");
const buttonReset = (0, compass_components_1.css)({
    padding: 0,
    margin: 0,
    background: 'none',
    border: 'none',
});
const expandButton = (0, compass_components_1.css)({
    display: 'flex',
    padding: 7,
    transition: 'transform .16s linear',
    transform: 'rotate(0deg)',
    '&:hover': {
        cursor: 'pointer',
    },
});
const expanded = (0, compass_components_1.css)({
    transform: 'rotate(90deg)',
});
const ExpandButton = ({ onClick, isExpanded }) => {
    return (react_1.default.createElement("button", { type: "button", tabIndex: -1, onClick: onClick, className: (0, compass_components_1.cx)(buttonReset, expandButton, isExpanded && expanded) },
        react_1.default.createElement(compass_components_1.Icon, { glyph: "CaretRight", size: "small" })));
};
const databaseItem = (0, compass_components_1.css)({
    height: constants_1.DATABASE_ROW_HEIGHT,
});
const itemButtonWrapper = (0, compass_components_1.css)({
    height: constants_1.DATABASE_ROW_HEIGHT,
    paddingRight: compass_components_1.spacing[1],
    paddingLeft: compass_components_1.spacing[2],
});
const databaseItemLabel = (0, compass_components_1.css)({
    marginLeft: compass_components_1.spacing[2],
});
const DatabaseItem = ({ id, name, posInSet, setSize, isExpanded, isActive, isReadOnly, isTabbable, style, onNamespaceAction, onDatabaseExpand, }) => {
    const [hoverProps, isHovered] = (0, compass_components_1.useHoverState)();
    const onExpandButtonClick = (0, react_1.useCallback)((evt) => {
        evt.stopPropagation();
        onDatabaseExpand(id, !isExpanded);
    }, [onDatabaseExpand, id, isExpanded]);
    const onDefaultAction = (0, react_1.useCallback)((evt) => {
        onNamespaceAction(evt.currentTarget.dataset.id, 'select-database');
    }, [onNamespaceAction]);
    const onAction = (0, react_1.useCallback)((action) => {
        onNamespaceAction(id, action);
    }, [id, onNamespaceAction]);
    const actions = (0, react_1.useMemo)(() => {
        return [
            {
                action: 'create-collection',
                icon: 'Plus',
                label: 'Create collection',
            },
            {
                action: 'drop-database',
                icon: 'Trash',
                label: 'Drop database',
            },
        ];
    }, []);
    return (react_1.default.createElement(tree_item_1.ItemContainer, { id: id, "data-testid": `sidebar-database-${id}`, level: 1, setSize: setSize, posInSet: posInSet, isExpanded: isExpanded, isActive: isActive, isTabbable: isTabbable, onDefaultAction: onDefaultAction, style: style, className: databaseItem, ...hoverProps },
        react_1.default.createElement(tree_item_1.ItemWrapper, null,
            react_1.default.createElement(tree_item_1.ItemButtonWrapper, { className: itemButtonWrapper },
                react_1.default.createElement(ExpandButton, { onClick: onExpandButtonClick, isExpanded: isExpanded }),
                react_1.default.createElement(compass_components_1.Icon, { glyph: "Database", size: "small" }),
                react_1.default.createElement(tree_item_1.ItemLabel, { className: databaseItemLabel, title: name }, name)),
            !isReadOnly && (react_1.default.createElement(compass_components_1.ItemActionControls, { onAction: onAction, isVisible: isActive || isHovered, "data-testid": "sidebar-database-item-actions", collapseToMenuThreshold: 3, iconSize: "small", actions: actions })))));
};
exports.DatabaseItem = DatabaseItem;
//# sourceMappingURL=database-item.js.map